<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DiretorType StructType
 * @subpackage Structs
 */
class DiretorType extends AbstractStructBase
{
    /**
     * The CPF
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CPFType
     */
    public $CPF;
    /**
     * The nome
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\NomeCompletoType
     */
    public $nome;
    /**
     * Constructor method for DiretorType
     * @uses DiretorType::setCPF()
     * @uses DiretorType::setNome()
     * @param \StructType\CPFType $cPF
     * @param \StructType\NomeCompletoType $nome
     */
    public function __construct(\StructType\CPFType $cPF = null, \StructType\NomeCompletoType $nome = null)
    {
        $this
            ->setCPF($cPF)
            ->setNome($nome);
    }
    /**
     * Get CPF value
     * @return \StructType\CPFType
     */
    public function getCPF()
    {
        return $this->CPF;
    }
    /**
     * Set CPF value
     * @param \StructType\CPFType $cPF
     * @return \StructType\DiretorType
     */
    public function setCPF(\StructType\CPFType $cPF = null)
    {
        $this->CPF = $cPF;
        return $this;
    }
    /**
     * Get nome value
     * @return \StructType\NomeCompletoType
     */
    public function getNome()
    {
        return $this->nome;
    }
    /**
     * Set nome value
     * @param \StructType\NomeCompletoType $nome
     * @return \StructType\DiretorType
     */
    public function setNome(\StructType\NomeCompletoType $nome = null)
    {
        $this->nome = $nome;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DiretorType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
