<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultadosLocalizacaoEstabelecimentoSaudeType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Lista de Estabelecimentos de Saúde Localizados | Resposta da paginação
 * @subpackage Structs
 */
class ResultadosLocalizacaoEstabelecimentoSaudeType extends AbstractStructBase
{
    /**
     * The ResultadoLocalizacaoEstabelecimentoSaude
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: resultadolocalizacao:ResultadoLocalizacaoEstabelecimentoSaude
     * @var \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType[]
     */
    public $ResultadoLocalizacaoEstabelecimentoSaude;
    /**
     * The Paginacao
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: paginacao:Paginacao
     * @var \StructType\PaginacaoType
     */
    public $Paginacao;
    /**
     * Constructor method for ResultadosLocalizacaoEstabelecimentoSaudeType
     * @uses ResultadosLocalizacaoEstabelecimentoSaudeType::setResultadoLocalizacaoEstabelecimentoSaude()
     * @uses ResultadosLocalizacaoEstabelecimentoSaudeType::setPaginacao()
     * @param \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType[] $resultadoLocalizacaoEstabelecimentoSaude
     * @param \StructType\PaginacaoType $paginacao
     */
    public function __construct(array $resultadoLocalizacaoEstabelecimentoSaude = array(), \StructType\PaginacaoType $paginacao = null)
    {
        $this
            ->setResultadoLocalizacaoEstabelecimentoSaude($resultadoLocalizacaoEstabelecimentoSaude)
            ->setPaginacao($paginacao);
    }
    /**
     * Get ResultadoLocalizacaoEstabelecimentoSaude value
     * @return \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType[]|null
     */
    public function getResultadoLocalizacaoEstabelecimentoSaude()
    {
        return $this->ResultadoLocalizacaoEstabelecimentoSaude;
    }
    /**
     * Set ResultadoLocalizacaoEstabelecimentoSaude value
     * @throws \InvalidArgumentException
     * @param \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType[] $resultadoLocalizacaoEstabelecimentoSaude
     * @return \StructType\ResultadosLocalizacaoEstabelecimentoSaudeType
     */
    public function setResultadoLocalizacaoEstabelecimentoSaude(array $resultadoLocalizacaoEstabelecimentoSaude = array())
    {
        foreach ($resultadoLocalizacaoEstabelecimentoSaude as $resultadosLocalizacaoEstabelecimentoSaudeTypeResultadoLocalizacaoEstabelecimentoSaudeItem) {
            // validation for constraint: itemType
            if (!$resultadosLocalizacaoEstabelecimentoSaudeTypeResultadoLocalizacaoEstabelecimentoSaudeItem instanceof \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType) {
                throw new \InvalidArgumentException(sprintf('The ResultadoLocalizacaoEstabelecimentoSaude property can only contain items of \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType, "%s" given', is_object($resultadosLocalizacaoEstabelecimentoSaudeTypeResultadoLocalizacaoEstabelecimentoSaudeItem) ? get_class($resultadosLocalizacaoEstabelecimentoSaudeTypeResultadoLocalizacaoEstabelecimentoSaudeItem) : gettype($resultadosLocalizacaoEstabelecimentoSaudeTypeResultadoLocalizacaoEstabelecimentoSaudeItem)), __LINE__);
            }
        }
        $this->ResultadoLocalizacaoEstabelecimentoSaude = $resultadoLocalizacaoEstabelecimentoSaude;
        return $this;
    }
    /**
     * Add item to ResultadoLocalizacaoEstabelecimentoSaude value
     * @throws \InvalidArgumentException
     * @param \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType $item
     * @return \StructType\ResultadosLocalizacaoEstabelecimentoSaudeType
     */
    public function addToResultadoLocalizacaoEstabelecimentoSaude(\StructType\ResultadoLocalizacaoEstabelecimentoSaudeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType) {
            throw new \InvalidArgumentException(sprintf('The ResultadoLocalizacaoEstabelecimentoSaude property can only contain items of \StructType\ResultadoLocalizacaoEstabelecimentoSaudeType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ResultadoLocalizacaoEstabelecimentoSaude[] = $item;
        return $this;
    }
    /**
     * Get Paginacao value
     * @return \StructType\PaginacaoType|null
     */
    public function getPaginacao()
    {
        return $this->Paginacao;
    }
    /**
     * Set Paginacao value
     * @param \StructType\PaginacaoType $paginacao
     * @return \StructType\ResultadosLocalizacaoEstabelecimentoSaudeType
     */
    public function setPaginacao(\StructType\PaginacaoType $paginacao = null)
    {
        $this->Paginacao = $paginacao;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResultadosLocalizacaoEstabelecimentoSaudeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
